classification
Title: distutils.sysconfig.customize_compiler will try to read variable that has not been initialized
Type: Stage: resolved
Components: Distutils Versions: Python 3.5, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: ned.deily Nosy List: alex, dstufft, eric.araujo, ned.deily, python-dev
Priority: normal Keywords: patch

Created on 2014-07-05 16:44 by alex, last changed 2014-07-07 04:30 by ned.deily. This issue is now closed.

Files
File name Uploaded Description Edit
sysconfig.diff alex, 2014-07-05 16:44 review
issue21923_3x.patch ned.deily, 2014-07-06 09:51 review
issue21923_27.patch ned.deily, 2014-07-06 09:52 review
Messages (5)
msg222373 - (view) Author: Alex Gaynor (alex) * (Python committer) Date: 2014-07-05 16:44
If one invokes some distutils code too early, this function will try to read ``_config_vars`` before it is initialized. http://bpaste.net/show/1DOGhL8sdnkPyLTL06AZ/ is an example traceback that results.

The attached patch uses the public API which guarantees that it is defined.
msg222400 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2014-07-06 09:51
Thanks for the patch, Alex, and sorry about the bug.  The fix looks good.  I've added a test that should be valid whether or not a compiler is available and, I hope, on Windows (I haven't tested it there).
msg222405 - (view) Author: Alex Gaynor (alex) * (Python committer) Date: 2014-07-06 14:11
Test looks reasonable to me.
msg222424 - (view) Author: Roundup Robot (python-dev) Date: 2014-07-06 23:18
New changeset bdbfbb57e37e by Ned Deily in branch '2.7':
Issue #21923: Prevent AttributeError in distutils.sysconfig.customize_compiler
http://hg.python.org/cpython/rev/bdbfbb57e37e

New changeset 78fa18e95445 by Ned Deily in branch '3.4':
Issue #21923: Prevent AttributeError in distutils.sysconfig.customize_compiler
http://hg.python.org/cpython/rev/78fa18e95445

New changeset 12546bfa1f4f by Ned Deily in branch 'default':
Issue #21923: merge from 3.4
http://hg.python.org/cpython/rev/12546bfa1f4f
msg222432 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2014-07-07 04:30
Committed for release in 2.7.9, 3.4.2, and 3.5.0.
History
Date User Action Args
2014-07-07 04:30:15ned.deilysetstatus: open -> closed
resolution: fixed
messages: + msg222432

stage: patch review -> resolved
2014-07-06 23:18:16python-devsetnosy: + python-dev
messages: + msg222424
2014-07-06 14:11:47alexsetmessages: + msg222405
2014-07-06 09:52:22ned.deilysetfiles: + issue21923_27.patch
2014-07-06 09:52:01ned.deilysetfiles: + issue21923_3x.patch

stage: patch review
messages: + msg222400
versions: + Python 3.5, - Python 3.2, Python 3.3
2014-07-05 17:36:40ned.deilysetassignee: ned.deily

nosy: + ned.deily
2014-07-05 16:44:20alexcreate